/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv168.gui;

import cz.muni.fi.pv168.entity.Person;
import cz.muni.fi.pv168.entity.Sex;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.ResourceBundle;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author bar
 */
public class PeopleTableModel extends AbstractTableModel{
    private List<Person> people = new ArrayList<Person>();
    private ResourceBundle localization;
    public PeopleTableModel(List<Person> people, ResourceBundle localization)
    {
        this.people.addAll(people); 
        this.localization = localization;
    }
    
    @Override
    public int getRowCount() {
        return people.size();
    }

    @Override
    public int getColumnCount() {
        return 3;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        if(rowIndex>=people.size())
            throw new IllegalArgumentException("Row Index out of bounds.");
        Person pers = people.get(rowIndex);
        switch(columnIndex)
        {
            case 0:return pers.getName();
            case 1:return pers.getAge();
            case 2:return pers.getSex();
            default:throw new IllegalArgumentException("Column index out of bounds.");
        }
    }
    
    @Override
    public String getColumnName(int columnIndex){
        switch(columnIndex){
            case 0:return localization.getString("name");
            case 1:return localization.getString("age");
            case 2:return localization.getString("sex");
        }
        return "";
    }
    
    public List<Person> getTableData(){
        return Collections.unmodifiableList(people);
    }
    
    @Override
    public boolean isCellEditable(int rowIndex,int columnIndex){
       return true; 
    }
    
    @Override
    public void setValueAt(Object obj,int rowIndex, int columnIndex){
        if(rowIndex>people.size())
            throw new IllegalArgumentException("row Index");
        Person pers = people.get(rowIndex); 
        switch(columnIndex){
            case 0:pers.setName((String)obj);
                break;
            case 1:pers.setAge((Integer)obj);
                break;
            case 2:pers.setSex((Sex)obj);
                break;
            default: throw new IllegalArgumentException("column index");
        }
    }

    void add(Person pers) {
        people.add(pers);
        fireTableDataChanged();
    }
    
}
